<?php
//
//  Nagios Core Config Manager
//  Copyright (c) 2010-2015 Nagios Enterprises, LLC
//
//  File: group_template.php
//  Desc: Creates the HTML output of any Group object. (Host Group, Service Group, Contact Group)
//
?>
<div id="visibleDivs">
    <div id="tab1">
        <h3><?php echo get_page_title($this->exactType); ?> <?php echo _("Management"); ?></h3>
        <div class="leftBox">
            <div class="ccm-row">
                <label for="tfName"><?php echo get_page_title($this->exactType); ?> <?php echo _("Name"); ?> <span class="req">*</span></label>
                <input name="tfName" type="text" id="tfName" value="<?php @val($FIELDS[$this->exactType.'_name']) ?>" class="required tf_wide">
            </div>
            <div class="ccm-row">
                <label for="tfFriendly"><?php echo _("Description"); ?> <span class="req">*</span></label>
                <input name="tfFriendly" class='required tf_wide' type="text" id="tfFriendly" value="<?php @val($FIELDS['alias']) ?>">
            </div>
            <?php
            // Host Group or Service Group only
            if ($this->exactType == 'hostgroup' || $this->exactType == 'servicegroup') {
            ?>
            <div class="ccm-row">
                <label for="tfNotes"><?php echo _("Notes"); ?></label>
                <input name="tfNotes" type="text" id="tfNotes" value="<?php @val($FIELDS['notes']); ?>" class="tf_wide">
            </div>
            <div class="ccm-row">
                <label for="tfNotesURL"><?php echo _("Notes URL"); ?></label>
                <input name="tfNotesURL" type="text" id="tfNotesURL" value="<?php @val($FIELDS['notes_url']); ?>" class="tf_wide">
            </div>
            <div class="ccm-row">
                <label for="tfActionURL"><?php echo _("Action URL"); ?></label>
                <input name="tfActionURL" type="text" id="tfActionURL" value="<?php @val($FIELDS['action_url']); ?>" class="tf_wide" />
            </div>
            <?php
            }
            
            // Check if the active button should be checked
            $active_checked = '';
            if ((isset($FIELDS['active']) && $FIELDS['active'] == '1') || !isset($FIELDS['active'])) {
                $active_checked = 'checked="checked"';
            }
            ?>
            <div class="ccm-row oneline">
                <label for="chbActive"><?php echo _("Active"); ?></label>
                <input name="chbActive" type="checkbox" class="checkbox" id="chbActive" value="1" <?php echo $active_checked; ?>>
                <i class="fa fa-info-circle tooltip-info" title="<?php echo _("Only active objects will be written to the config files and appear in Nagios. Inactive objects will only be shown in the CCM."); ?>"></i>
            </div>
        </div>
        <div class="rightBox">
            <h3><?php echo _("Memberships"); ?></h3>
            <?php
            // Host Groups only
            if ($this->exactType == 'hostgroup') {
            ?>
            <p><a class='linkBox' href="javascript:overlay('hostBox')" title="Assign to Hosts"><?php echo _("Manage Hosts"); ?></a></p>
            <p><a class='linkBox' href="javascript:overlay('hostgroupBox')" title="Manage Hostgroups"><?php echo _("Manage Hostgroups"); ?></a></p>
            <?php 
            }

            // Service Groups only
            if ($this->exactType == 'servicegroup') {
            ?>          
            <p><a class='linkBox' href="javascript:overlay('hostserviceBox')" title="Manage Services"><?php echo _("Manage Services"); ?></a></p>
            <p><a class='linkBox' href="javascript:overlay('servicegroupBox')" title="Manage Servicegroups"><?php echo _("Manage Servicegroups"); ?></a></p>
            <?php 
            }

            // Contact Groups only
            if ($this->exactType == 'contactgroup') {
            ?>
            <p><a class='linkBox' href="javascript:overlay('contactBox')" title="Manage Contacts"><?php echo _("Manage Contacts"); ?></a></p>
            <p><a class='linkBox' href="javascript:overlay('contactgroupBox')" title="Manage Contactgroups"><?php echo _("Manage Contactgroups"); ?></a></p>
            <?php 
            }
            ?>
        </div>
     </div>
 </div>